summaryrefslogtreecommitdiff
path: root/scripts/sysvinit/codeq-web
diff options
context:
space:
mode:
Diffstat (limited to 'scripts/sysvinit/codeq-web')
-rwxr-xr-xscripts/sysvinit/codeq-web141
1 files changed, 141 insertions, 0 deletions
diff --git a/scripts/sysvinit/codeq-web b/scripts/sysvinit/codeq-web
new file mode 100755
index 0000000..56a2f35
--- /dev/null
+++ b/scripts/sysvinit/codeq-web
@@ -0,0 +1,141 @@
+#! /bin/sh
+### BEGIN INIT INFO
+# Provides: codeq-web
+# Required-Start: $local_fs $remote_fs $network codeq-server
+# Required-Stop: $local_fs $remote_fs codeq-server
+# Default-Start: 2 3 4 5
+# Default-Stop: 0 1 6
+# Short-Description: CodeQ web services initscript
+# Description: Init script for running CodeQ web services as a daemon
+### END INIT INFO
+
+# Author: Aleš Smodiš <aless@guru.si>
+
+# Do NOT "set -e"
+
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+DESC="CodeQ web services daemon"
+NAME=codeq-web
+PIDFILE=/var/run/$NAME.pid
+SCRIPTNAME=/etc/init.d/$NAME
+
+# Read configuration variable file if it is present
+[ -r /etc/default/codeq ] && . /etc/default/codeq
+
+NODEJS=/usr/bin/nodejs
+SCRIPT=$CODEQ_SERVER/web/main.js
+
+# Exit if Node is not installed
+[ -x "$NODEJS" ] || exit 0
+# Exit if the script does not exist
+[ -f "$SCRIPT" ] || exit 0
+
+# Load the VERBOSE setting and other rcS variables
+. /lib/init/vars.sh
+
+# Define LSB log_* functions.
+# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
+# and status_of_proc is working.
+. /lib/lsb/init-functions
+
+#
+# Function that starts the daemon/service
+#
+do_start()
+{
+ # Return
+ # 0 if daemon has been started
+ # 1 if daemon was already running
+ # 2 if daemon could not be started
+ export CODEQ_WEB_LOG
+ start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $NODEJS --background --make-pidfile --test > /dev/null \
+ || return 1
+ start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $NODEJS --background --make-pidfile -- $SCRIPT \
+ || return 2
+}
+
+#
+# Function that stops the daemon/service
+#
+do_stop()
+{
+ # Return
+ # 0 if daemon has been stopped
+ # 1 if daemon was already stopped
+ # 2 if daemon could not be stopped
+ # other if a failure occurred
+ start-stop-daemon --stop --quiet --pidfile $PIDFILE --retry=TERM/15/KILL/5 --remove-pidfile
+ RETVAL="$?"
+ return "$RETVAL"
+}
+
+#
+# Function that sends a SIGHUP to the daemon/service
+#
+do_reload() {
+ #
+ # If the daemon can reload its configuration without
+ # restarting (for example, when it is sent a SIGHUP),
+ # then implement that here.
+ #
+ start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
+ return 0
+}
+
+case "$1" in
+ start)
+ [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC"
+ do_start
+ case "$?" in
+ 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+ 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+ esac
+ ;;
+ stop)
+ [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC"
+ do_stop
+ case "$?" in
+ 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+ 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+ esac
+ ;;
+ status)
+ status_of_proc -p $PIDFILE "$NODEJS" $NAME && exit 0 || exit $?
+ ;;
+ #reload|force-reload)
+ #
+ # If do_reload() is not implemented then leave this commented out
+ # and leave 'force-reload' as an alias for 'restart'.
+ #
+ #log_daemon_msg "Reloading $DESC"
+ #do_reload
+ #log_end_msg $?
+ #;;
+ restart|force-reload)
+ #
+ # If the "reload" option is implemented then remove the
+ # 'force-reload' alias
+ #
+ log_daemon_msg "Restarting $DESC"
+ do_stop
+ case "$?" in
+ 0|1)
+ do_start
+ case "$?" in
+ 0) log_end_msg 0 ;;
+ 1) log_end_msg 1 ;; # Old process is still running
+ *) log_end_msg 1 ;; # Failed to start
+ esac
+ ;;
+ *)
+ # Failed to stop
+ log_end_msg 1
+ ;;
+ esac
+ ;;
+ *)
+ echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
+ exit 3
+ ;;
+esac